#include "listas.h"
#include <string.h>
#include <stdlib.h>

int contarnodos(struct alumno **H){
	int i;
	struct alumno *q;
	
	// inicializo q al primer nodo, mientras exista, avanzo al siguiente y sumo
	for(i = 0, q = *H; q; i++, q = q->next);
	
	return i;
}

void swapnodo(struct alumno *p, struct alumno *q) {
	struct alumno aux, *next1, *next2;
	
	// Guardo los punteros originales a los siguientes nodos
	next1 = p->next;
	next2 = q->next;
	
	// copio el contenido de p a aux
	memcpy(&aux, p, sizeof(struct alumno));
	// copio el contenido de q a p
	memcpy(p, q, sizeof(struct alumno));
	// copio el contenido de aux a q
	memcpy(q, &aux, sizeof(struct alumno));
	
	// Restauro los punteros originales a los nodos siguientes
	p->next = next1;
	q->next = next2;
}

void queue(struct alumno **H, struct alumno *q) {
	struct alumno *aux;
	if(!*H) {
		// si la lista esta vacia, lo meto de una
		*H = q;
	} else {
		// sino, busco el ultimo
		for(aux = *H; aux->next; aux = aux->next);
		// lo encolo
		aux->next = q;
	}
	// hago apuntar el ultimo a NULL para indicar el fin de la lista
	q->next = NULL;
}

int pop(struct alumno **H, struct alumno *q) {
	struct alumno *aux;
	if(!*H) {
		return 0;
	}
	if(*H != q) {
		// comienzo a recorrer la lista
		aux = *H;
		// mientras que el siguiente no sea el que busco, sigo
		while(aux->next != q) aux = aux->next;
		// lo encontre, hago apuntar el actual al que viene despues del que
		// voy a liberar
		aux->next = q->next;
	}
	// lo libero.
	free(q);
	return 1;
}
