#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <errno.h>
#include "listas.h"

int leeropcion(void) {
	int opcion;
	
	printf("\n  Menu principal:\n");
	printf("1  INGRESAR Datos\n");
	printf("2  IMPRIMIR Datos\n");
	printf("3  BORRAR   Datos\n");
	printf("4  BUSCAR   Datos\n");
	printf("5  ORDENAR  Datos\n");
	printf("6  GUARDAR  Datos\n");
	printf("7  SALIR\n");

	printf("Ingrese una opcion 1 - 7 :  ");
	scanf("%d",&opcion);
	
	return opcion;
}

int cargarlista(struct alumno **H, char *archivo) {
	FILE *f;
	struct alumno *q;
	int cant;
	char buffer[1024];
	
	f = fopen(archivo, "r");
	
	if(!f) return 0;
	
	for(cant = 0; !feof(f); cant++) {
		// limpio buffer, cargo datos
		memset(buffer, 0, 1024);
		fgets(buffer, 1024, f);
		// la primera linea que lea seran las columnas, asi que las ignoro
		if(cant == 0) {
			cant++;
			continue; 
		}
		// pido memoria
		q = malloc(sizeof(struct alumno));
		if(!q) { // compruebo errores de malloc
			fprintf(stderr, "Error en malloc(), razon: %s\n", strerror(errno));
			return 0;
		}
		if(leerentrada(buffer, q)) {
			// leerentrada devuelve 1 en caso de error, libero la memoria que pedi
			free(q);
			continue;
		}
		// todo ok, encolo
		queue(H, q);
	}
	fclose(f);
	return cant;
}

int leerentrada(char *str, struct alumno *q) {
	char *token;
	char *separador = ";";
	
	/* inicializo el tokenizer con el string a separar, y el string
	 * con el separador de los tokens.
	 * strtok() me devuelve el puntero al primer campo en la primera llamada
	 * o NULL en caso de falla. Si algo fallo, retorno un 1, de lo contrario,
	 * copio el valor en el campo de la estructura, recordando pasarlo a entero.
	 */
	token = strtok(str, separador);
	if(!token) return 1;
	else q->legajo = atoi(token); 
	
	/* Las siguientes llamadas a la funcion van con NULL en el parametro
	 * del string, para indicar que sigo separando el mismo. Le paso el mismo
	 * parametro del separador, para seguir separando con los mismos valores.
	 */
	token = strtok(NULL, separador);
	if(!token) return 1;
	else strcpy(q->nombre, token);
	
	token = strtok(NULL, separador);
	if(!token) return 1;
	else strcpy(q->apellido, token);
	
	token = strtok(NULL, separador);
	if(!token) return 1;
	else strcpy(q->email, token);
	
	token = strtok(NULL, separador);
	if(!token) return 1;
	else q->nota1p = atoi(token);
	
	token = strtok(NULL, separador);
	if(!token) return 1;
	else q->nota2p = atoi(token);
	
	token = strtok(NULL, separador);
	if(!token) return 1;
	else q->notatp = atoi(token);
	
	return 0;
}

void ingresardato(struct alumno **H) {
	struct alumno *q;
	int ok;
	char str[3];
	
	q = malloc(sizeof(struct alumno));
	if(!q) {
		fprintf(stderr, "Error en malloc(), razon: %s\n", strerror(errno));
		return;
	}
	
	do {
		ok = 1;
		printf("Ingrese nro de legajo: ");
		scanf("%d", &q->legajo);
		printf("Ingrese nombre: ");
		scanf("%s", q->nombre);
		printf("Ingrese apellido: ");
		scanf("%s", q->apellido);
		printf("Ingrese email: ");
		scanf("%s", q->email);
		printf("Ingrese nota del primer parcial: ");
		scanf("%d", &q->nota1p);
		printf("Ingrese nota del segundo parcial: ");
		scanf("%d", &q->nota2p);
		printf("Ingrese nota del TP final: ");
		scanf("%d", &q->notatp);
		
		printf("\nDatos:\n");
		imprimirnodo(q);
		printf("\nSon correctos los datos? s/n: ");
		scanf("%s", str); 
		if(str[0]=='n' || str[0]=='N') ok = 0;
	} while(ok != 1);
	
	queue(H, q);
}

void borrardato(struct alumno **H) {
	int opcion;
	struct alumno *q;
	// vector de punteros a funcion que buscan segun un criterio a elegir
	struct alumno *(*func[7])(struct alumno **);
	
	// cargo en cada uno de los punteros del vector la direccion de comienzo
	// de las funciones que quiero ejecutar
	func[0] = buscarporlegajo;
	func[1] = buscarpornombre;
	func[2] = buscarporapellido;
	func[3] = buscarporemail;
	func[4] = buscarpornota1p;
	func[5] = buscarpornota2p;
	func[6] = buscarpornotatp;
	
	printf("Ingrese critero de busqueda: ");
	imprimircriterios();
	scanf("%d", &opcion);
	
	// Si es una opcion valida...
	if(opcion >=1 && opcion <=7) {
		// ...ejecuto la funcion del vector correspondiente a la opcion elegida. 
		q = func[opcion - 1](H);
		if(q) {
			// si se encontro, saco el nodo
			pop(H, q);
		} else {
			printf("No encontrado.\n");
			return;
		}
	 } else if (opcion == 0) {
	 	// si la opcion es 0, cancelar.
	 	return;
	 } else {
	 	// en caso de funcion incorrecta, llamo recursivamente para volver.
	 	fprintf(stderr, "Opcion incorrecta, intentelo de nuevo\n");
	 	borrardato(H);
	 }
	 return;	
}

void buscardato(struct alumno **H) {
	int opcion;
	struct alumno *q;
	struct alumno *(*func[7])(struct alumno **);
	
	func[0] = buscarporlegajo;
	func[1] = buscarpornombre;
	func[2] = buscarporapellido;
	func[3] = buscarporemail;
	func[4] = buscarpornota1p;
	func[5] = buscarpornota2p;
	func[6] = buscarpornotatp;
	
	printf("Ingrese critero de busqueda: ");
	imprimircriterios();
	scanf("%d", &opcion);
	
	if(opcion >=1 && opcion <=7) {
		q = func[opcion - 1](H);
		if(q) {
			imprimirnodo(q);
		} else {
			printf("No encontrado.\n");
			return;
		}
	 } else if (opcion == 0) {
	 	return;
	 } else {
	 	fprintf(stderr, "Opcion incorrecta, intentelo de nuevo\n");
	 	buscardato(H);
	 }
	 return;	
}

void ordenardatos(struct alumno **H) {
	int opcion;
	void (*func[7])(struct alumno **);
	
	func[0] = ordenarporlegajo;
	func[1] = ordenarpornombre;
	func[2] = ordenarporapellido;
	func[3] = ordenarporemail;
	func[4] = ordenarpornota1p;
	func[5] = ordenarpornota2p;
	func[6] = ordenarpornotatp;
	
	printf("Ingrese critero de ordenamiento: ");
	imprimircriterios();
	scanf("%d", &opcion);
	
	if(opcion >=1 && opcion <=7) {
		func[opcion - 1](H);
	 } else if (opcion == 0) {
	 	return;
	 } else {
	 	fprintf(stderr, "Opcion incorrecta, intentelo de nuevo\n");
	 	ordenardatos(H);
	 }
	 return;
}

void imprimircriterios(void) {
	printf("\n");
	printf("1 Legajo\n");
	printf("2 Nombre\n");
	printf("3 Apellido\n");
	printf("4 Email\n");
	printf("5 Nota 1er parcial\n");
	printf("6 Nota 2do parcial\n");
	printf("7 Nota TP final\n");
}

void guardardatos(struct alumno **H) {
	FILE *f;
	char archivo[100];
	struct alumno *q;
	
	printf("Ingrese archivo a guardar: ");
	scanf("%s", archivo);
	
	f = fopen(archivo, "w");
	if(!f) {
		fprintf(stderr, "Error guardando lista en archivo: %s Razon: %s\n",
			archivo, strerror(errno));
		return;
	}
	q = *H;
	// Cabecera con las columnas para poder importar en el excel
	fprintf(f, "Legajo;Nombre;Apellido;Email;Nota 1er parcial;Nota 2do parcial;Nota TP final;\n");
	while(q) {
		// mientras q no apunte a NULL, recorro la lista imprimiendo en el archivo los valores
		fprintf(f, "%d;%s;%s;%s;%d;%d;%d;\n", q->legajo, q->nombre, q->apellido,
			q->email, q->nota1p, q->nota2p, q->notatp);
		q = q->next;
	}
	fclose(f);
}

void imprimirdatos(struct alumno **H) {
	struct alumno *q;
	q = *H;
	while(q) { 
		imprimirnodo(q);
		q = q->next;
	}
}

void imprimirnodo(struct alumno *q) {
	printf("\n");
	printf("Legajo: %d\n", q->legajo);
	printf("Nombre: %s\n", q->nombre);
	printf("Apellido: %s\n", q->apellido);
	printf("Email: %s\n", q->email);
	printf("Nota 1er parcial: %d\n", q->nota1p);
	printf("Nota 2do parcial: %d\n", q->nota2p);
	printf("Nota TP final: %d\n", q->notatp);
}

void liberarlista(struct alumno **H) {
	struct alumno *q;
	// mientras queden nodos en la lista (es decir, *H no sea NULL)...
	while(*H) {
		// copio el nodo a liberar
		q = *H;
		// muevo la lista al siguiente
		(*H) = q->next;
		// libero el nodo
		free(q);
	}
}

int main(int argc, char *argv[]) {
	struct alumno *H = NULL;
	int opcion;
	int cant;
	
	printf("Bienvenido al ejemplo de listas!\n");
	
	if(argc ==  2) {
		cant = cargarlista(&H, argv[1]);
		if(!cant) {
			fprintf(stderr, "Error cargando lista preexistente del archivo: %s Razon: %s\n", 
				argv[1], strerror(errno));
		} else {
			printf("Cargados %d alumnos del archivo %s exitosamente.\n", cant, argv[1]);
		}
	}
	
	do {
		opcion = leeropcion();
		switch(opcion) {
			case 1:
				ingresardato(&H);
				break;
			case 2:
				imprimirdatos(&H);
				break;
			case 3:
				borrardato(&H);
				break;
			case 4:
				buscardato(&H);
				break;
			case 5:
				ordenardatos(&H);
				break;
			case 6:
				guardardatos(&H);
				break;
			case 7:
				printf("Chau!\n\n");
				//liberarlista(&H);
				break;
			default:
				printf("Opcion incorrecta!\n");
				break;
		}
	} while(opcion != 7);
	
	return 0;
}
